SystemOrganization addCategory: #WorkPlayRatioScheduler!
SystemOrganization addCategory: #'WorkPlayRatioScheduler-test'!

Object subclass: #WPRSFormOutput
	instanceVariableNames: 'scheduler waffle form canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WPRSFormOutput methodsFor: 'changing' stamp: 'HwaJong 12/29/2012 18:46'!
compute
	form := Form extent: self formWidth @ self formHeight depth: 1.
	canvas := FormCanvas on: form.
	canvas fillColor: Color white.
	canvas line: self hrStartX stop @ self rowHeight to: self hrEndX @ self rowHeight color: Color black.
	canvas line: self firstLineX @ self lineStartY to: self firstLineX @ self lineEndY color: Color black.
	canvas line: self secondLineX @ self lineStartY to: self secondLineX @ self lineEndY color: Color black.
	canvas line: self thirdLineX @ self lineStartY to: self thirdLineX @ self lineEndY color: Color black.
	canvas drawCenterString: 'Work' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 1).
	canvas drawCenterString: 'Play' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 2).
	canvas drawCenterString: 'Work' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 3).
	canvas drawCenterString: 'Play' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 4).
	(1 to: (scheduler schedule size min: 20))
		do: [ :index | 
			| pair |
			pair := scheduler schedule at: index.
			canvas drawCenterString: pair first printString in: (waffle boundsOfIndentationAtRow: index + 1 atColumn: 1).
			canvas drawCenterString: pair second printString in: (waffle boundsOfIndentationAtRow: index + 1 atColumn: 2) ].
	((21) to: scheduler schedule size)
		do: [ :index | 
			| pair dIndex |
			dIndex := index - 20.
			pair := scheduler schedule at: index.
			canvas drawCenterString: pair first printString in: (waffle boundsOfIndentationAtRow: dIndex + 1 atColumn: 3).
			canvas drawCenterString: pair second printString in: (waffle boundsOfIndentationAtRow: dIndex + 1 atColumn: 4) ].
	canvas drawString: Date today printString at: 90 @ (self lineEndY + 7)! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:57'!
dateMargin
	^43! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:50'!
firstLineX
	^(waffle columnSegments rangeOfSegmentAtIndex: 3) start! !

!WPRSFormOutput methodsFor: 'accessing' stamp: 'HwaJong 12/29/2012 18:19'!
form
	^ form! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 18:07'!
formHeight
	^waffle bounds height + self dateMargin! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:48'!
formWidth
	^waffle bounds width! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:38'!
hrEndX
	^self formWidth-10! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:48'!
hrStartX
	^waffle columnSegments rangeOfSegmentAtIndex: 1! !

!WPRSFormOutput methodsFor: 'initialize-release' stamp: 'HwaJong 12/29/2012 18:50'!
initialize
	super initialize.
	self initializeWaffle.! !

!WPRSFormOutput methodsFor: 'initialize-release' stamp: 'HwaJong 12/29/2012 18:50'!
initializeWaffle
	|cw|
	waffle := WFWaffleLayout new.
	waffle addFixedRowSegment: 0.
	waffle addFixedRowSegment: 15.
	waffle addFixedRowSegment: 1.
	20
		timesRepeat: [ 
			waffle addFixedRowSegment: 18.
			waffle addFixedRowSegment: 1 ].
	cw := 69.
	waffle addFixedColumnSegment: 10.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 10.
	waffle bounds: (0 @ 0 extent: (waffle columnSegments sumOfLengthOfFixedSegments) @ (waffle rowSegments sumOfLengthOfFixedSegments)).! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:36'!
lineEndY
	^self formHeight - self dateMargin.! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:35'!
lineStartY
	^0! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:32'!
rowHeight
	^15! !

!WPRSFormOutput methodsFor: 'accessing' stamp: 'HwaJong 12/27/2012 10:30'!
scheduler: aWorkPlayRatioScheduler 
	scheduler := aWorkPlayRatioScheduler! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:50'!
secondLineX
	^(waffle columnSegments rangeOfSegmentAtIndex: 5) start! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:51'!
thirdLineX 
	^(waffle columnSegments rangeOfSegmentAtIndex: 7) start! !

Object subclass: #WorkPlayRatioScheduler
	instanceVariableNames: 'workMin workPerPlayRatio mins schedule maxWorkMin maxPlayMin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 12/27/2012 18:24'!
outputScheduleForm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 23 minute: 0 second: 0) meals: 2.
s workPerPlayRatio: 9/3.
s workMin: 1.
s compute. 
s schedule explore.
s openForm.
s saveFormToPNGName: '/Users/daliot/Desktop/print.png'.! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:02'!
ratio4hour4
|s|
s := WorkPlayRatioScheduler new.
s hours: 4.
s workPerPlayRatio: 4.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:03'!
ratio5hour8
|s|
s := WorkPlayRatioScheduler new.
s hours: 8.
s workPerPlayRatio: 5.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 12/27/2012 18:24'!
work5play3upto9pm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 21 minute: 0 second: 0) meals: 3.
s workPerPlayRatio: 5/3.
s workMin: 1.
s compute. 
^s schedule.

! !

!WorkPlayRatioScheduler methodsFor: 'adding' stamp: 'HwaJong 11/23/2012 14:56'!
addEntryToSchedule
schedule addLast: self workPlayEntry! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 1/10/2013 16:17'!
compute
[self addEntryToSchedule.
self reduceMins.
mins > 0]
	whileTrue:
		[self increaseWorkMin].! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
hours: anInteger
self mins: anInteger * 60! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 1/10/2013 16:22'!
increaseWorkMin
|oldWorkMin|
oldWorkMin := workMin.
workMin := workMin + 1.
(maxWorkMin notNil and: [workMin > maxWorkMin])
	ifTrue: [ ^workMin := oldWorkMin ].
(maxPlayMin notNil and: [self playMin > maxPlayMin])
	ifTrue: [ ^workMin := oldWorkMin ].! !

!WorkPlayRatioScheduler methodsFor: 'initialize-release' stamp: 'HwaJong 12/27/2012 10:19'!
initialize 
super initialize.
schedule := OrderedCollection new.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 1/10/2013 16:16'!
maxPlayMin: aSmallInteger 
	maxPlayMin := aSmallInteger! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 1/10/2013 16:15'!
maxWorkMin: aSmallInteger 
	maxWorkMin := aSmallInteger! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
mins: anInteger
mins := anInteger! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:54'!
openForm
	self scheduleForm asMorph openInWindowLabeled: 'Schedule'! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:48'!
playMin
^(workMin / workPerPlayRatio) rounded max: 1! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 1/10/2013 16:17'!
reduceMins
mins := mins - workMin - self playMin.! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:53'!
saveFormToPNGName: aString 
	PNGReadWriter putForm: self scheduleForm onFileNamed: aString! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 15:00'!
schedule
	^ schedule! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/27/2012 10:49'!
scheduleForm
	^WPRSFormOutput new
		scheduler: self;
		compute;
		form.! !

!WorkPlayRatioScheduler methodsFor: 'express access' stamp: 'HwaJong 1/14/2013 09:21'!
workFrom: timeStart to: timeEnd meals: anInteger 
	self mins: (((timeEnd asSeconds - timeStart asSeconds) / 60) truncated - (60*anInteger)).! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin
	^ workMin! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin: anInteger
	workMin := anInteger
! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio
	^ workPerPlayRatio! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio: aNumber
	workPerPlayRatio := aNumber
! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:49'!
workPlayEntry
^{workMin . self playMin}! !

!WorkPlayRatioScheduler methodsFor: 'express access' stamp: 'HwaJong 1/14/2013 09:22'!
workUpTo: aTime meals: anInteger
	^self workFrom: Time now to: aTime meals: anInteger.! !

TestCase subclass: #WorkPlayRatioSchedulerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler-test'!

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:32'!
testMaxPlayMin
|s|
s := WorkPlayRatioScheduler new.
s mins: 300.
s workPerPlayRatio: 18/4.
s workMin: 1.
s maxPlayMin: 3.
s compute. 
self assert: s schedule asArray equals:  #(#(1 1) #(2 1) #(3 1) #(4 1) #(5 1) #(6 1) #(7 2) #(8 2) #(9 2) #(10 2) #(11 2) #(12 3) #(13 3) #(14 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3) #(15 3)).! !

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:27'!
testMaxWorkMin
|s|
s := WorkPlayRatioScheduler new.
s mins: 300.
s workPerPlayRatio: 18/4.
s workMin: 1.
s maxWorkMin: 18.
s compute. 
self assert: s schedule asArray equals:  #(#(1 1) #(2 1) #(3 1) #(4 1) #(5 1) #(6 1) #(7 2) #(8 2) #(9 2) #(10 2) #(11 2) #(12 3) #(13 3) #(14 3) #(15 3) #(16 4) #(17 4) #(18 4) #(18 4) #(18 4) #(18 4) #(18 4) #(18 4)).! !

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:33'!
testRatio4hour4
|s|
s := WorkPlayRatioScheduler new.
s hours: 4.
s workPerPlayRatio: 4.
s workMin: 1.
s compute. 
self assert: s schedule asArray equals: #(#(1 1) #(2 1) #(3 1) #(4 1) #(5 1) #(6 2) #(7 2) #(8 2) #(9 2) #(10 3) #(11 3) #(12 3) #(13 3) #(14 4) #(15 4) #(16 4) #(17 4) #(18 5) #(19 5)).! !

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:34'!
testRatio5hour8
|s|
s := WorkPlayRatioScheduler new.
s hours: 8.
s workPerPlayRatio: 5.
s workMin: 1.
s compute. 
self assert: s schedule asArray equals: #(#(1 1) #(2 1) #(3 1) #(4 1) #(5 1) #(6 1) #(7 1) #(8 2) #(9 2) #(10 2) #(11 2) #(12 2) #(13 3) #(14 3) #(15 3) #(16 3) #(17 3) #(18 4) #(19 4) #(20 4) #(21 4) #(22 4) #(23 5) #(24 5) #(25 5) #(26 5) #(27 5) #(28 6)).! !

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:35'!
testWork5play3upto9pm
|s|
s := WorkPlayRatioScheduler new.
s mins: 100.
s workPerPlayRatio: 5/3.
s workMin: 1.
s compute. 
self assert: s schedule asArray equals: #(#(1 1) #(2 1) #(3 2) #(4 2) #(5 3) #(6 4) #(7 4) #(8 5) #(9 5) #(10 6) #(11 7)).! !

!WorkPlayRatioSchedulerTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:47'!
testWork9Play3
|s|
s := WorkPlayRatioScheduler new.
s mins: 100.
s workPerPlayRatio: 9/3.
s workMin: 1.
s compute. 
self assert: s schedule asArray equals: #(#(1 1) #(2 1) #(3 1) #(4 1) #(5 2) #(6 2) #(7 2) #(8 3) #(9 3) #(10 3) #(11 4) #(12 4))! !
